import { cloneWithStyle, getInheritedStyle, styleFromCSSStyleRule } from "./lib/extract";
import browser from "webextension-polyfill";

console.log("Hello from content!");

browser.runtime.onMessage.addListener((event, sender, sendResponse) => {
    console.log("Got message", event);
    if (event.type != "cloneWithStyle") {
        return;
    }
    console.log("Cloning with style");
    const { elementSelector, id } = event;
    try {
        const element = document.querySelector(elementSelector) as HTMLElement;
        if (!element) {
            console.error("Element not found");
            return;
        }
        return cloneWithStyle(element).then((vnode) => {
            const inheritedStyle = getInheritedStyle(element);
            const ret = {
                type: "cloneWithStyleResult",
                vnode,
                inheritedStyle,
                id
            };
            console.log("Sending response", ret);
            return (ret);
        });
    }
    catch (e) {
        console.error("Error cloning with style", e);
    }
});

// const functionCallTable = {
//     cloneWithStyle,
//     styleFromCSSStyleRule
// } as any;
// window.addEventListener("message", async (event) => {
//     if (event.source !== window) {
//         return;
//     }
//     if (event.data.type !== "functionCall") {
//         return;
//     }
//     const { functionName, args, id } = event.data;
//     if (!functionCallTable[functionName]) {
//         console.error(`Function ${functionName} not found`);
//         return;
//     }
//     const result = await functionCallTable[functionName](...args);
//     window.postMessage({ type: "functionCallResult", result, id }, "*");
// });